package cn.com.infosec.asn1.cms;

import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Set;
import cn.com.infosec.asn1.DEREncodableVector;
import cn.com.infosec.asn1.DERObjectIdentifier;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

public class AttributeTable {
   private Hashtable attributes;

   public AttributeTable(Hashtable attrs) {
      this.attributes = new Hashtable();
      this.attributes = this.copyTable(attrs);
   }

   public AttributeTable(DEREncodableVector v) {
      Hashtable var2;
      var2 = new Hashtable.<init>();
      this.attributes = var2;

      for(int var4 = 0; var4 != v.size(); ++var4) {
         Attribute var3;
         this.addAttribute((var3 = Attribute.getInstance(v.get(var4))).getAttrType(), var3);
      }

   }

   public AttributeTable(ASN1Set s) {
      Hashtable var2;
      var2 = new Hashtable.<init>();
      this.attributes = var2;

      for(int var4 = 0; var4 != s.size(); ++var4) {
         Attribute var3;
         this.addAttribute((var3 = Attribute.getInstance(s.getObjectAt(var4))).getAttrType(), var3);
      }

   }

   private void addAttribute(DERObjectIdentifier oid, Attribute a) {
      Object var3;
      if ((var3 = this.attributes.get(oid)) == null) {
         this.attributes.put(oid, a);
      } else {
         Vector var4;
         if (var3 instanceof Attribute) {
            Vector var10000 = var4 = new Vector;
            var10000.<init>();
            var10000.addElement(var3);
            var10000.addElement(a);
         } else {
            (var4 = (Vector)var3).addElement(a);
         }

         this.attributes.put(oid, var4);
      }

   }

   private Hashtable copyTable(Hashtable param1) {
      // $FF: Couldn't be decompiled
   }

   public Attribute get(DERObjectIdentifier oid) {
      Object var2;
      return (var2 = this.attributes.get(oid)) instanceof Vector ? (Attribute)((Vector)var2).elementAt(0) : (Attribute)var2;
   }

   public ASN1EncodableVector getAll(DERObjectIdentifier oid) {
      AttributeTable var10000 = this;
      ASN1EncodableVector var3;
      var3 = new ASN1EncodableVector.<init>();
      Object oid1;
      if ((oid1 = var10000.attributes.get(oid)) instanceof Vector) {
         Enumeration var2 = ((Vector)oid1).elements();

         while(var2.hasMoreElements()) {
            var3.add((Attribute)var2.nextElement());
         }
      } else if (oid1 != null) {
         var3.add((Attribute)oid1);
      }

      return var3;
   }

   public Hashtable toHashtable() {
      return this.copyTable(this.attributes);
   }

   public ASN1EncodableVector toASN1EncodableVector() {
      AttributeTable var10000 = this;
      ASN1EncodableVector var4;
      var4 = new ASN1EncodableVector.<init>();
      Enumeration var1 = var10000.attributes.elements();

      while(true) {
         while(var1.hasMoreElements()) {
            Object var2;
            if ((var2 = var1.nextElement()) instanceof Vector) {
               Enumeration var3 = ((Vector)var2).elements();

               while(var3.hasMoreElements()) {
                  var4.add(Attribute.getInstance(var3.nextElement()));
               }
            } else {
               var4.add(Attribute.getInstance(var2));
            }
         }

         return var4;
      }
   }
}
